1.引入库
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
题目大意:给定两个四位数的素数,要求将一个素数通过变换各个位从而得到所需的素数,每变一位需要花费1英镑且变换后的数必须为素数,问最少需要花费多少英镑。
2.读入数据
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
3.代码如下:
#include<math.h>
#include<queue>
#include<stdio.h>
#include<string.h>
using namespace std;
int a,b;
int p[999999]={0};
int v[999999]={0};
bool prime(int x) //判断是否是素数
{
int i;
for(i=2;i<=sqrt((double)x);i++)
{
if(x%i==0)
return 0;
}
return 1;
}
int bfs(int s,int r)
{
queue<int> q;
q.push(s);
p[s]=0;
v[s]=1;
while(!q.empty())
{
int t=q.front();
q.pop();
for(int i=0;i<=9;i++) //每一位可能存在的数字
{
int y1=(t/10)*10+i; //个位
if(prime(y1)&&!v[y1]) //这个数是素数且没有遍历过
{
q.push(y1); //进栈
v[y1]=1;
p[y1]=p[t]+1; //标记这个数且加一即可
}
int y2=t%10+(t/100)*100+i*10;//十位
if(prime(y2)&&!v[y2])
{
q.push(y2);
v[y2]=1;
p[y2]=p[t]+1;
}
int y3=t%100+(t/1000)*1000+i*100;//百位
if(prime(y3)&&!v[y3])
{
q.push(y3);
v[y3]=1;
p[y3]=p[t]+1;
}
if(i!=0) //首位要注意不能为零
{
int y4=t%1000+i*1000; //千位
if(prime(y4)&&!v[y4])
{
q.push(y4);
v[y4]=1;
p[y4]=p[t]+1;
}
}
}
if(v[r]) //r=b且已经遍历
return p[r];
}
return 0;
}
int main()
{
int T;
scanf("%d",&T);
while(T--)
{
memset(v,0,sizeof(v));
memset(p,0,sizeof(p));
scanf("%d %d",&a,&b);
printf("%d\n",bfs(a,b));
}
return 0;
}